{
  description = "CoreDNS";
  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable-small";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = {self, flake-utils, nixpkgs }: 
    with nixpkgs.lib;
    let
      packageConfigBase = flake-utils.lib.eachDefaultSystem (system:
        let
          pkgs = nixpkgs.legacyPackages.${system};
          pkg = pkgs.callPackage ./package.nix {};
        in
        {
          packages = rec {
            putex = pkg;
            default = pkg;
          };
        }
      );
      nixosModules = rec {
        putex = import ./nixos-module.nix self nixpkgs.lib;
        default = putex;
      };
      nixosConfigurations = {
        container = nixpkgs.lib.nixosSystem {
          system = "x86_64-linux";
          modules = [
            self.nixosModules.default
            {
              networking.useDHCP = false; boot.isContainer = true; system.stateVersion = "24.05";

              services.putex.putexes."testputex" = {};

            }
          ];
        };
      };
      in
      packageConfigBase // {
        inherit nixosModules nixosConfigurations;
      };
}
